Package org.zkoss.stateless.sul

## Interface IButton

- All Superinterfaces:
    `IAnyGroup<IButton>`, `IButtonBase<IButton>`, `IChildrenOfInputgroup<IButton>`, `IComponent<IButton>`, `IHtmlBasedComponent<IButton>`, `ILabelElement<IButton>`, `ILabelImageElement<IButton>`, `IXulElement<IButton>`

      public interface IButton
      extends IButtonBase<IButton>, IAnyGroup<IButton>

  Immutable `Button` component

  You could assign a `label` and an `image` to a button by the `label` and `image` attributes. If both are specified, the `dir` attribute control which is displayed up front, and the `orient` attribute controls whether the layout is horizontal or vertical.

  ### Support @Action

  Name | Action Type
  --- | ---
  onFocus | Denotes when a component gets the focus.
  onBlur | Denotes when a component loses the focus.
  onUpload | ActionData: `FileData` Denotes user has uploaded a file to the component.

  Author:
    katherine
  See Also:
    `Button`

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Interface | Description
    --- | --- | ---
    `static class` | `IButton.Builder` | Builds instances of type `IButton`.
    `static class` | `IButton.Updater` | Builds an updater of type `IButton` for `UiAgent.smartUpdate(Locator, SmartUpdater)`.

    - ### Nested classes/interfaces inherited from interface org.zkoss.stateless.sul.IButtonBase

      `IButtonBase.Direction, IButtonBase.Orient, IButtonBase.Type`

  - ### Field Summary

    Fields
    Modifier and Type | Field | Description
    --- | --- | ---
    `static IButton` | `DEFAULT` | Constant for default attributes of this immutable component.

  - ### Method Summary

    All Methods Static Methods Instance Methods Default Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `default java.lang.String` | `getWidgetClass()` | Returns the client widget class.
    `static IButton` | `of​(java.lang.String label)` | Returns the instance with the given label.
    `static IButton` | `of​(java.lang.String label, java.lang.String image)` | Returns the instance with the given label and image.
    `static IButton` | `ofDir​(IButtonBase.Direction dir)` | Returns the instance with the given dir.
    `static IButton` | `ofId​(java.lang.String id)` | Returns the instance with the given id.
    `static IButton` | `ofImage​(java.lang.String image)` | Returns the instance with the given image.
    `static IButton` | `ofOrient​(IButtonBase.Orient orient)` | Returns the instance with the given orient.
    `static IButton` | `ofType​(IButtonBase.Type type)` | Returns the instance with the given type.

    - ### Methods inherited from interface org.zkoss.stateless.sul.IButtonBase

      `checkOrient, getAutodisable, getDir, getHref, getOrient, getTarget, getType, getUpload, isDisabled, withAutodisable, withDir, withDir, withDisabled, withHref, withOrient, withOrient, withTarget, withType, withType, withUpload`

    - ### Methods inherited from interface org.zkoss.stateless.sul.IComponent

      `getAction, getActions, getClientAttributes, getId, getMold, getWidgetListeners, getWidgetOverrides, isVisible, withAction, withAction, withAction, withAction, withAction, withAction, withAction, withAction, withAction, withAction, withAction, withActions, withActions, withClientAttribute, withClientAttributes, withId, withMold, withVisible, withWidgetClass, withWidgetListener, withWidgetListeners, withWidgetOverride, withWidgetOverrides`

    - ### Methods inherited from interface org.zkoss.stateless.sul.IHtmlBasedComponent

      `getClientAction, getDraggable, getDroppable, getHeight, getHflex, getLeft, getRenderdefer, getSclass, getStyle, getTabindex, getTooltiptext, getTop, getVflex, getWidth, getZclass, getZIndex, isFocus, withClientAction, withDraggable, withDroppable, withFocus, withHeight, withHflex, withLeft, withRenderdefer, withSclass, withStyle, withTabindex, withTabindex, withTooltiptext, withTop, withVflex, withWidth, withZclass, withZIndex`

    - ### Methods inherited from interface org.zkoss.stateless.sul.ILabelElement

      `getLabel, withLabel`

    - ### Methods inherited from interface org.zkoss.stateless.sul.ILabelImageElement

      `getHoverImage, getIconSclass, getIconSclasses, getIconTooltip, getIconTooltips, getImage, isPreloadImage, withHoverImage, withIconSclass, withIconSclasses, withIconTooltip, withIconTooltips, withImage, withPreloadImage`

    - ### Methods inherited from interface org.zkoss.stateless.sul.IXulElement

      `getContext, getCtrlKeys, getPopup, getTooltip, withContext, withCtrlKeys, withPopup, withTooltip`

- - ### Field Detail

    - #### DEFAULT

          static final IButton DEFAULT

      Constant for default attributes of this immutable component.

  - ### Method Detail

    - #### getWidgetClass

          default java.lang.String getWidgetClass()

      Returns the client widget class.

      Default: `"zul.wgt.Button"`

      Specified by:
        `getWidgetClass` in interface `IComponent<IButton>`

    - #### of

          static IButton of​(java.lang.String label)

      Returns the instance with the given label.
      Parameters:
        `label` - The label that the component

    - #### of

          static IButton of​(java.lang.String label,
                            java.lang.String image)

      Returns the instance with the given label and image.
      Parameters:
        `label` - The label that the button holds.
        `image` - The image that the button holds.

    - #### ofImage

          static IButton ofImage​(java.lang.String image)

      Returns the instance with the given image.
      Parameters:
        `image` - The image that the button holds.

    - #### ofOrient

          static IButton ofOrient​(IButtonBase.Orient orient)

      Returns the instance with the given orient.
      Parameters:
        `orient` - The button orient

    - #### ofType

          static IButton ofType​(IButtonBase.Type type)

      Returns the instance with the given type.
      Parameters:
        `type` - The button type

    - #### ofDir

          static IButton ofDir​(IButtonBase.Direction dir)

      Returns the instance with the given dir.
      Parameters:
        `dir` - The button dir

    - #### ofId

          static IButton ofId​(java.lang.String id)

      Returns the instance with the given id.
      Parameters:
        `id` - The id to identify this component